
; ----------------------------------------------------------------------
;  Start point of 1st algo to test
; ----------------------------------------------------------------------

.data
even
	Algo1_Description	db	"Alex / MMX"
				db	0

.code
align 16

Algo1_Run	proc	lpResult:DWORD

	; if you will add your tested code to shis file, the comment next 2 lines
	;mov eax,ALGO_IS_NOT_IMPLEMENTED
	;ret
	
	pushad
	
	; checking for supporting of this algo by CPU
	; specify which instructions is used by your code,
	; choose from the list:
	; 	ALGO_REQUIRE_i486
	; 	ALGO_REQUIRE_MMX
	;	ALGO_REQUIRE_SSE1
	;	ALGO_REQUIRE_SSE2
	;	ALGO_REQUIRE_SSE3
	;	ALGO_REQUIRE_SSSE3
	;	ALGO_REQUIRE_SSE41
	;	ALGO_REQUIRE_SSE42
	
	mov eax,2
	cmp dwMaxInstructionsSupported,ALGO_REQUIRE_MMX		; select your instructions
	jb @algo1_exit


	; here can be placed anything - preparation of the algo
	; (allocation of memory etc) and calling to algo itself
	; or just placing of piece of code between timing macros

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	
		; labels for the code
		; you must place tested code (proc or just piece)
		; between that labels - just move them to needed place
		;algo1_start::
		.data?
			align 16
			MMXTestBuffer	CHAR_INFO CharNumber dup (<>)
			TestAlexConvertArea PROTO :DWORD, :DWORD, :DWORD
		.code
		
		INVOKE TestAlexConvertArea, ADDR MMXTestBuffer, ADDR FileBuffer, NumCycles		
		
		;algo1_end::
	
	counter_end
	
	; return the counter of the clocks to variable by reference
	mov ecx,lpResult
	mov [ecx],eax
	
	xor eax,eax
	
	@algo1_exit:
	
	; exit with restoration all of regs except EAX - return code
	mov dword ptr [esp+28],eax
	popad
	ret
	
Algo1_Run	endp


; uncomment these labels, and put code between them, if you
; used proc instead of piece of the code. Comment labels at proc above

algo1_start::
 TestAlexConvertArea PROC DestBuffer:DWORD, SourceBuffer:DWORD, NumCyclesToDo:DWORD

    mov  esi, SourceBuffer
    mov  edi, DestBuffer
    
    mov  ecx, NumCyclesToDo
    mov  eax, NumCyclesToDo
    pxor mm7,mm7
    and ecx,1
    
    @@:
    
    movd mm0,dword ptr [esi]
    punpcklbw mm0,mm7
    add esi,4
    movq qword ptr [edi],mm0
    add edi,8
    add eax, -1
    jnz @B

    
    jecxz @ConvDone
    movzx eax,word ptr [esi]
    mov [edi],al
    mov [edi+2],ah   
        
    @ConvDone:

    ret 
    
 TestAlexConvertArea ENDP
algo1_end::


; ----------------------------------------------------------------------
;  End point of 1st algo to test
; ----------------------------------------------------------------------

